#!/usr/bin/env ruby

require 'date'

INTERVAL = 10
hostname = `hostname`.strip
STDOUT.sync = true

loop do
  seen = {}
  count = 0

  addr = nil
  starts = nil
  ends = nil

  IO::readlines("/var/lib/dhcp/dhcpd.leases").each do |line|
    if line =~ /^lease (.+) \{/
      addr = $1

      starts = nil
      ends = nil
    elsif line =~ /starts \d+ (.+?);/
      starts = DateTime.parse $1
    elsif line =~ /ends \d+ (.+?);/
      ends = DateTime.parse $1
    elsif line =~ /^\}/
      now = DateTime.now
      if starts and ends and
         starts <= now and ends >= now and

        unless seen[addr]
          count += 1
          seen[addr] = true
        end
      end
    end
  end
  puts "PUTVAL \"#{hostname}/exec-dhcpd/current_sessions-leases\" interval=#{INTERVAL} N:#{count}"

  sleep INTERVAL
end
